#include "msp430g2553.h"
#include "display.h"


/***************************/
void WriteComd(unsigned char comd);
void WriteData(unsigned char data);
void Delay_Xms(unsigned int Xms);
void InitST7565(void);
void DispPic(unsigned char *dispdata,unsigned char seg0,unsigned char seg1);
void InitST7567(void);
void LCD_clear(void);
void DispHZ(unsigned char *dispdata,unsigned char page,
             unsigned char seg0,unsigned char seg1);
void DispASCII(unsigned char *dispdata,unsigned char page,
             unsigned char seg0,unsigned char seg1);


void main(void)
{
  volatile unsigned int i;

  WDTCTL = WDTPW + WDTHOLD;                 // Stop watchdog timer
  P1OUT = 0x00;                             // P1 setup for LED & reset output
  P1DIR |= BIT0 + BIT5;                     //
  P1SEL = BIT1 + BIT2 + BIT4;
  P1SEL2 = BIT1 + BIT2 + BIT4;
  P2DIR = BIT0 + BIT1 + BIT2;               //P20,P21,P22 OUTPUT
  P2OUT = BIT0 + BIT1 + BIT2;               //P20,P21,P22 OUTPUT
  
  UCA0CTL0 |= UCCKPH + UCMSB + UCMST + UCSYNC;  // 3-pin, 8-bit SPI master
  UCA0CTL1 |= UCSSEL_2;                     // SMCLK
  UCA0BR0 |= 0x01;                          // /2 Ƶ
  UCA0BR1 = 0;                              //    ƵӣUCxxBR0 + UCxxBR1 *256
  UCA0MCTL = 0;                             // No modulation
  UCA0CTL1 &= ~UCSWRST;                     // **Initialize USCI state machine**  
  P1OUT &= ~BIT5;                           // Now with SPI signals initialized,
  P1OUT |= BIT5;                            // reset slave

  __delay_cycles(75);                 // Wait for slave to initialize
  
  //InitST7567();
  
  InitST7565();
  LCD_clear();

  /***'й' display**********/
  DispPic( CCB_LOGO1,0x10,0x00 );
  DispHZ(zhong,0xb5,0x12,0x04);
  DispHZ(guo,0xb5,0x13,0x04);
  DispHZ(jian,0xb5,0x14,0x04);
  DispHZ(she,0xb5,0x15,0x04);
  DispHZ(yin,0xb5,0x16,0x04);
  DispHZ(hang,0xb5,0x17,0x04);

  //LCD_clear();

 /***'Ϣ' display**********/
 /* DispHZ(xin,0xb4,0x10,0x04);
  DispHZ(xi,0xb4,0x11,0x04);
  DispHZ(xin1,0xb4,0x12,0x04);
  DispHZ(xi1,0xb4,0x13,0x04);
  DispHZ(zhi,0xb4,0x14,0x04);
 // DispHZ(neng,0xb4,0x15,0x04);*/
  
 /* DispASCII(ASC,0xb6,0x10,0x00);
  DispASCII(ASC,0xb6,0x10,0x08);
  DispASCII(ASC,0xb6,0x11,0x00);
  DispASCII(ASC,0xb6,0x11,0x08);
  DispASCII(ASC,0xb6,0x12,0x00);
  DispASCII(ASC,0xb6,0x12,0x08);
  DispASCII(ASC,0xb6,0x13,0x00);
  DispASCII(ASC,0xb6,0x13,0x08);
  DispASCII(ASC,0xb6,0x14,0x00);
  DispASCII(ASC,0xb6,0x14,0x08);
  DispASCII(ASC,0xb6,0x15,0x00);
  DispASCII(ASC,0xb6,0x15,0x08);
  DispASCII(ASC,0xb6,0x16,0x00);
  DispASCII(ASC,0xb6,0x16,0x08);
  DispASCII(ASC,0xb6,0x17,0x00);
  DispASCII(ASC,0xb6,0x17,0x08);*/

  //DispHZ(yin,0xb5,0x16,0x04);
  //DispHZ(hang,0xb5,0x17,0x04);  
  

  //DispPic( CCB_LOGO1,0x12,0x08 );

  while(1)
  {
    
  }
}
void InitST7567(void)
{
}

void InitST7565(void)
{ //Ӳλ
  //P2OUT &= ~BIT1;
  //Delay_Xms(5);	// 
  //P2OUT |= BIT1;
 // Delay_Xms(5);	// 
  
  WriteComd(0xe2);	//soft resetʼλ
  WriteComd(0xa2);	//bias selectȷΪ1/6BIAS  1/33duty
  WriteComd(0xa0);	// ADC selectȷSEGɨseg0--->seg131 mx=0
  WriteComd(0xc8);	//SHL selectȷCOMΪɨcom63--->com0 my=1
  WriteComd(0x23);	//趨(1 + Rb/Ra)=6.5
  WriteComd(0x81);	//The Electronic Volume (Double Byte Command)ֵλVOѹ(ҲǶԱȶ)ֽ
  WriteComd(0X04);	
  WriteComd(0x2c);	//power control1 onڲѹ·,򿪵·
  WriteComd(0x2e);	//power control2
  WriteComd(0x2f);	//power control3
  WriteComd(0xf1);	//The Booster Ratio (Double Byte Command)趨ѹ,ֽ
  WriteComd(0x00);	//"00"4ѹ,"01"5ѹ,"03"6ѹ
  WriteComd(0x60);	//趨ʼе1
  WriteComd(0xb3);	//Set page address 
  WriteComd(0xa4);	//Display All Points ON/OFF to Normal display modeʾģʽѡ
  WriteComd(0xaf);	//Display ON/OFFʾ趨
  
}



void WriteComd(unsigned char comd)
{
  P2OUT = 0x02;                    //RS = 0; RST = 1; CS = 0;  
  _NOP(); _NOP();
  UCA0TXBUF = comd;
  UCA0CTL1 &= ~UCSWRST;
  _NOP(); _NOP(); 
  P2OUT = 0x03;                   //RS = 0; RST = 1; CS = 1; 
}

void WriteData(unsigned char data)
{
  P2OUT = 0x06;                    //RS = 1; RST = 1; CS = 0; 
  _NOP(); _NOP(); _NOP();
  UCA0TXBUF = data;
  UCA0CTL1 &= ~UCSWRST;
  _NOP(); _NOP(); _NOP();
  P2OUT = 0x07;                   //RS = 1; RST = 1; CS = 1; 
}

void Delay_Xms(unsigned int Xms)
{//ʱms
  unsigned int i,j;
  for(i=0;i<Xms;i++)
    for(j=0;j<150;j++);//ʱĻԼ1ms
}


/*****ͼƬʾ******************************************************/
void DispPic(unsigned char *dispdata,unsigned char seg0,unsigned char seg1)
{
  unsigned char i,page;			//ֲַ
  unsigned int j=0;			//ֲͱ
  page=0xb4;				//ʼʼɨҳ
  while(page<0xb8)		    	//4ҳ
  {
    WriteComd(page);	//趨ɨҳ
    WriteComd(seg0);	//趨ʼSEG,ֽ
    WriteComd(seg1);
    for(i=0;i<36;i++)
    {//д132SEG
      WriteData(dispdata[j]);	//ʾݽдʾ
      //WriteData(0xf0);
      j++; 
    }
    page++;	//ҳԶ1
  }
}

/***ʾ********/
void DispHZ(unsigned char *dispdata,unsigned char page,
             unsigned char seg0,unsigned char seg1)
{
  unsigned int j=0;			//ֲͱ
  unsigned char i;
  WriteComd(page);	//趨ɨҳ
  WriteComd(seg0);	//趨ʼSEG,ֽ
  WriteComd(seg1);
  for(i=0;i<16;i++)
  {
    WriteData(dispdata[j]);	//ʾݽдʾ
    j++; 
  }

  WriteComd(page+1);	//趨ɨҳ
  WriteComd(seg0);	//趨ʼSEG,ֽ
  WriteComd(seg1);
  for(i=16;i<32;i++)
  {
    WriteData(dispdata[j]);	//ʾݽдʾ
    j++; 
  }
}

/***ASCII ʾ********/
void DispASCII(unsigned char *dispdata,unsigned char page,
             unsigned char seg0,unsigned char seg1)
{
  unsigned int j=0;			//ֲͱ
  unsigned char i;
  WriteComd(page);	//趨ɨҳ
  WriteComd(seg0);	//趨ʼSEG,ֽ
  WriteComd(seg1);
  for(i=0;i<8;i++)
  {
    WriteData(dispdata[j]);	//ʾݽдʾ
    j++; 
  }

  WriteComd(page+1);	//趨ɨҳ
  WriteComd(seg0);	//趨ʼSEG,ֽ
  WriteComd(seg1);
  for(i=8;i<16;i++)
  {
    WriteData(dispdata[j]);	//ʾݽдʾ
    j++; 
  }
}

void LCD_clear(void)
{
  unsigned char i,page;			//ֲַ
  unsigned int j=0;			//ֲͱ
  page=0xb4;				//ʼʼɨҳ
  while(page<0xb8)		    	//4ҳ
  {
    WriteComd(page);	//趨ɨҳ
    WriteComd(0x10);	//趨ʼSEG,ֽ
    WriteComd(0x00);
    for(i=0;i<132;i++)
    {//д132SEG
      P2OUT = 0x06;                    //RS = 1; RST = 1; CS = 0; 
      _NOP(); _NOP(); //_NOP();
      UCA0TXBUF = 0x00;
      UCA0CTL1 &= ~UCSWRST;
      _NOP(); _NOP(); //_NOP(); 
      P2OUT = 0x07;                   //RS = 1; RST = 1; CS = 1;
      j++; 
    }   
    
    page++;	//ҳԶ1
    }   
}
