#include "msp430g2553.h"

static int da;

void delay(int t)
{
	int s=500;
	for(;t>0;t--)
	{
		for(;s>0;s--)
		{
			;
			;
		}
	}
}

void write_com(char com)
{
	P2OUT&=~(1<<3);
	P2OUT&=~(1<<4);
	P2OUT&=~(1<<5);
	delay(8);
	P1OUT=com;
	delay(8);
	P2OUT|=(1<<5);
	delay(8);
	P2OUT&=~(1<<5);
 }

void write_data(char dt)
{
	P2OUT|=(1<<3);
	P2OUT&=~(1<<4);
	P2OUT&=~(1<<5);
	delay(8);
	P1OUT=dt;
	delay(8);
	P2OUT|=(1<<5);
	delay(8);
	P2OUT&=~(1<<5);
 }

void initial_lcd(void)
{
	delay(20);
	write_com(0x38);
	delay(15);
	write_com(0x0f);
	delay(15);
	write_com(0x06);
	delay(15);
	write_com(0x00)	;
}

void lcd_dis (char hang,char lie,char spr[])
{
	if(hang==1)
    {
        char g=0;
		write_com(0x80+lie);
		do
		{
			write_data(spr[g]);
            g++;
		}
    	while(spr[g]!='\0');
    }
	else if(hang==2)
    {
        char g=0;
		write_com(0x80+0x40+lie);
    	do
		{
			write_data(spr[g]);
            g++;
		}
    	while(spr[g]!='\0');
	}
}

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;                 
  ADC10CTL0 = ADC10SHT_2 + ADC10ON + ADC10IE; 
ADC10CTL1 = INCH_1;                      
  ADC10AE0 |= 0x02;                         
  P1DIR |= 0xff;                           
  P2DIR |= 0x38;
  initial_lcd();
  for (;;)
  {
//ADC10CTL0 |= ENC + ADC10SC;            
//    __bis_SR_register(GIE);       
      da=ADC10MEM;
      delay(2000);
	  write_com(0x84);
	  delay(2000);
	  write_data((da/100)+0x30);
	  delay(2000);
	  write_data((da%100/10)+0x30);
	  delay(2000);
	  write_data((da%100%10)+0x30);
	  delay(2000);

  }
}